    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * ShipNeedle.java
    029     * ---------------
    030     * (C) Copyright 2002-2008, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * Changes:
    037     * --------
    038     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    039     * 27-Mar-2003 : Implemented Serializable (DG);
    040     * 09-Sep-2003 : Added equals() method (DG);
    041     * 08-Jun-2005 : Implemented Cloneable (DG);
    042     * 22-Nov-2007 : Implemented hashCode() (DG);
    043     *
    044     */
    045
    046    package org.jfree.chart.needle;
    047
    048    import java.awt.Graphics2D;
    049    import java.awt.geom.Arc2D;
    050    import java.awt.geom.GeneralPath;
    051    import java.awt.geom.Point2D;
    052    import java.awt.geom.Rectangle2D;
    053    import java.io.Serializable;
    054
    055    /**
    056     * A needle in the shape of a ship, for use with the
    057     * {@link org.jfree.chart.plot.CompassPlot} class.
    058     */
    059    public class ShipNeedle extends MeterNeedle
    060                            implements Cloneable, Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = 149554868169435612L;
    064
    065        /**
    066         * Draws the needle.
    067         *
    068         * @param g2  the graphics device.
    069         * @param plotArea  the plot area.
    070         * @param rotate  the rotation point.
    071         * @param angle  the angle.
    072         */
    073        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    074                                  Point2D rotate, double angle) {
    075
    076            GeneralPath shape = new GeneralPath();
    077            shape.append(new Arc2D.Double(-9.0, -7.0, 10, 14, 0.0, 25.5,
    078                    Arc2D.OPEN), true);
    079            shape.append(new Arc2D.Double(0.0, -7.0, 10, 14, 154.5, 25.5,
    080                    Arc2D.OPEN), true);
    081            shape.closePath();
    082            getTransform().setToTranslation(plotArea.getMinX(), plotArea.getMaxY());
    083            getTransform().scale(plotArea.getWidth(), plotArea.getHeight() / 3);
    084            shape.transform(getTransform());
    085
    086            if ((rotate != null) && (angle != 0)) {
    087                /// we have rotation
    088                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    089                shape.transform(getTransform());
    090            }
    091
    092            defaultDisplay(g2, shape);
    093        }
    094
    095        /**
    096         * Tests another object for equality with this object.
    097         *
    098         * @param object  the object to test.
    099         *
    100         * @return A boolean.
    101         */
    102        public boolean equals(Object object) {
    103            if (object == null) {
    104                return false;
    105            }
    106            if (object == this) {
    107                return true;
    108            }
    109            if (super.equals(object) && object instanceof ShipNeedle) {
    110                return true;
    111            }
    112            return false;
    113        }
    114
    115        /**
    116         * Returns a hash code for this instance.
    117         *
    118         * @return A hash code.
    119         */
    120        public int hashCode() {
    121            return super.hashCode();
    122        }
    123
    124        /**
    125         * Returns a clone of this needle.
    126         *
    127         * @return A clone.
    128         *
    129         * @throws CloneNotSupportedException if the <code>ShipNeedle</code>
    130         *     cannot be cloned (in theory, this should not happen).
    131         */
    132        public Object clone() throws CloneNotSupportedException {
    133            return super.clone();
    134        }
    135
    136    }
    137